#ifndef _PCI7003_DEVICE_
#define _PCI7003_DEVICE_


#define PCI7003_REG_MAX_CHANNELS		2	// ֧2ͨ

//***********************************************************
// ûӿ
#ifndef _PCI7003_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	// ڱ豸
	HANDLE DEVAPI FAR PASCAL PCI7003_CreateDevice(LONG lDeviceID = 0);		// 豸
	HANDLE DEVAPI FAR PASCAL PCI7003_CreateDeviceEx(LONG lPhysIdx = 0);		// ID豸
	int DEVAPI FAR PASCAL PCI7003_GetDeviceCount(HANDLE hDevice);			// ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCI7003_ListDeviceDlg(HANDLE hDevice);			// бϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PCI7003_ReleaseDevice(HANDLE hDevice);			// ر豸,ֹ,ͷԴ


	// ################################ 豸Ϣ ################################
	BOOL DEVAPI FAR PASCAL PCI7003_GetPhysIdx(				// , ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pPhysIdx);		// ص

	BOOL DEVAPI FAR PASCAL PCI7003_SetPhysIdx(				// , ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nPhysIdx);		// 

	BOOL DEVAPI FAR PASCAL PCI7003_GetDevVersion(			// ȡ豸̼汾
									HANDLE hDevice,			// 豸,CreateDevice
									PULONG pulFmwVersion,	// ̼汾
									PULONG pulDriverVersion);// 汾

	BOOL DEVAPI FAR PASCAL PCI7003_GetSerialNum(			// к, ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pSerialNum);		// صк

	BOOL DEVAPI FAR PASCAL PCI7003_GetUserPID(				// ûƷID(User Product Identification), ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									PULONG pUserPID);		// صûƷID

	BOOL DEVAPI FAR PASCAL PCI7003_SetUserPID(				// ûƷID(User Product Identification), ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nUserPID);		// ûƷID

	BOOL DEVAPI FAR PASCAL PCI7003_SetPowerOnRes(				// , ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									double dResistance,		// ֵ(0.0125ŷ204.7875ŷ,0.0125)
									ULONG lChannel);		// ͨѡ(01)

	BOOL DEVAPI FAR PASCAL PCI7003_GetPowerOnRes(			// ȡϵֵ, ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									double* pResistance,	// ֵ(0.0125ŷ204.7875ŷ,0.0125)
									ULONG lChannel);		// ͨѡ(01)

	// ################################ 뺯 ################################
	BOOL DEVAPI FAR PASCAL PCI7003_SetPassword(ULONG nPassword);// ޸к

	// ################################ 豸Ϣ ################################
	BOOL DEVAPI FAR PASCAL PCI7003_SetSerialNum(			// к, ɹʱTRUE,򷵻FALSE,ɵGetLastError()ԭ
									HANDLE hDevice,			// 豸,DEV_Create()
									ULONG nSerialNum);		// к

	//############################ ɱ̵ƺ #######################################
	BOOL DEVAPI FAR PASCAL PCI7003_SetResistance(			// ֵͨ
									HANDLE hDevice,			// 豸,CreateDevice
									double dResistance,		// ֵ(0.0125ŷ204.7875ŷ,0.0125)
									ULONG lChannel);		// ͨѡ(01)

	BOOL DEVAPI FAR PASCAL PCI7003_GetResistance(			// ȡֵͨ
									HANDLE hDevice,			// 豸,CreateDevice
									double* pResistance,	// ֵ(0.0125ŷ204.7875ŷ,0.0125)
									ULONG lChannel);		// ͨѡ(01)

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCI7003_GetDeviceBar(			// ȡָָ豸ĴBARַ
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵

	BOOL DEVAPI FAR PASCAL PCI7003_WriteRegisterByte(		// ָĴռλд뵥
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbLinearAddr,	// ָĴԻַ,GetDeviceAddrеpbLinearAddrֵ
									ULONG OffsetBytes,		// Իַַƫλ(ֽ)
									BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PCI7003_WriteRegisterWord(		// д˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									WORD Value);

	BOOL DEVAPI FAR PASCAL PCI7003_WriteRegisterULong(		// дĽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									ULONG Value);

	BYTE DEVAPI FAR PASCAL PCI7003_ReadRegisterByte(		// 뵥ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PCI7003_ReadRegisterWord(		// ˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PCI7003_ReadRegisterULong(		// ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
	BOOL DEVAPI FAR PASCAL PCI7003_WritePortByte(			// 8λд˿
									HANDLE hDevice,			// 豸(CreateDevice)
									__int64 pPort,			// ˿ڵַ
									BYTE Value);			// д8λ

	BOOL DEVAPI FAR PASCAL PCI7003_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
	BOOL DEVAPI FAR PASCAL PCI7003_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

	BYTE DEVAPI FAR PASCAL PCI7003_ReadPortByte(HANDLE hDevice, __int64 pPort);
	WORD DEVAPI FAR PASCAL PCI7003_ReadPortWord(HANDLE hDevice, __int64 pPort);
	ULONG DEVAPI FAR PASCAL PCI7003_ReadPortULong(HANDLE hDevice, __int64 pPort);

	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL PCI7003_CreateSystemEvent(void);			// ں¼󣬹InitDeviceIntVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCI7003_ReleaseSystemEvent(HANDLE hEvent);	// ͷں¼


#ifdef __cplusplus
}
#endif

// Զ
#ifndef _PCI7003_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PCI7003_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCI7003_32.dll...")
		#pragma message("======== Successfully linked with PCI7003_32.dll")
	#else
		#pragma comment(lib, "PCI7003_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCI7003_64.dll...")
		#pragma message("======== Successfully linked with PCI7003_64.dll")
	#endif

#endif

#endif // _PCI7003_DEVICE_
